/*
 * 
 */
package net.officefloor.model.office;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class OfficeSectionResponsibilityModel extends AbstractModel implements ItemModel<OfficeSectionResponsibilityModel> {

    public static enum OfficeSectionResponsibilityEvent {
     CHANGE_OFFICE_SECTION_RESPONSIBILITY_NAME, CHANGE_OFFICE_TEAM, ADD_OFFICE_SECTION_RESPONSIBILITY_OBJECT, REMOVE_OFFICE_SECTION_RESPONSIBILITY_OBJECT
    }

    /**
     * Default constructor.
     */
    public OfficeSectionResponsibilityModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public OfficeSectionResponsibilityModel(
      String officeSectionResponsibilityName
    ) {
        this.officeSectionResponsibilityName = officeSectionResponsibilityName;
    }

    /**
     * Convenience constructor.
     */
    public OfficeSectionResponsibilityModel(
      String officeSectionResponsibilityName
    , OfficeSectionResponsibilityToOfficeTeamModel officeTeam
    , OfficeSectionResponsibilityObjectModel[] officeSectionResponsibilityObject
    ) {
        this.officeSectionResponsibilityName = officeSectionResponsibilityName;
        this.officeTeam = officeTeam;
        if (officeSectionResponsibilityObject != null) {
            for (OfficeSectionResponsibilityObjectModel model : officeSectionResponsibilityObject) {
                this.officeSectionResponsibilityObject.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public OfficeSectionResponsibilityModel(
      String officeSectionResponsibilityName
    , OfficeSectionResponsibilityToOfficeTeamModel officeTeam
    , OfficeSectionResponsibilityObjectModel[] officeSectionResponsibilityObject
    , int x
    , int y
    ) {
        this.officeSectionResponsibilityName = officeSectionResponsibilityName;
        this.officeTeam = officeTeam;
        if (officeSectionResponsibilityObject != null) {
            for (OfficeSectionResponsibilityObjectModel model : officeSectionResponsibilityObject) {
                this.officeSectionResponsibilityObject.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Office section responsibility name.
     */
    private String officeSectionResponsibilityName;

    public String getOfficeSectionResponsibilityName() {
        return this.officeSectionResponsibilityName;
    }

    public void setOfficeSectionResponsibilityName(String officeSectionResponsibilityName) {
        String oldValue = this.officeSectionResponsibilityName;
        this.officeSectionResponsibilityName = officeSectionResponsibilityName;
        this.changeField(oldValue, this.officeSectionResponsibilityName, OfficeSectionResponsibilityEvent.CHANGE_OFFICE_SECTION_RESPONSIBILITY_NAME);
    }

    /**
     * Office team.
     */
    private OfficeSectionResponsibilityToOfficeTeamModel officeTeam;

    public OfficeSectionResponsibilityToOfficeTeamModel getOfficeTeam() {
        return this.officeTeam;
    }

    public void setOfficeTeam(OfficeSectionResponsibilityToOfficeTeamModel officeTeam) {
        OfficeSectionResponsibilityToOfficeTeamModel oldValue = this.officeTeam;
        this.officeTeam = officeTeam;
        this.changeField(oldValue, this.officeTeam, OfficeSectionResponsibilityEvent.CHANGE_OFFICE_TEAM);
    }


    /**
     * Office section responsibility object.
     */
    private List<OfficeSectionResponsibilityObjectModel> officeSectionResponsibilityObject = new LinkedList<OfficeSectionResponsibilityObjectModel>();

    public List<OfficeSectionResponsibilityObjectModel> getOfficeSectionResponsibilityObjects() {
        return this.officeSectionResponsibilityObject;
    }

    public void addOfficeSectionResponsibilityObject(OfficeSectionResponsibilityObjectModel officeSectionResponsibilityObject) {
        this.addItemToList(officeSectionResponsibilityObject, this.officeSectionResponsibilityObject, OfficeSectionResponsibilityEvent.ADD_OFFICE_SECTION_RESPONSIBILITY_OBJECT);
    }

    public void removeOfficeSectionResponsibilityObject(OfficeSectionResponsibilityObjectModel officeSectionResponsibilityObject) {
        this.removeItemFromList(officeSectionResponsibilityObject, this.officeSectionResponsibilityObject, OfficeSectionResponsibilityEvent.REMOVE_OFFICE_SECTION_RESPONSIBILITY_OBJECT);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<OfficeSectionResponsibilityModel> removeConnections() {
        RemoveConnectionsAction<OfficeSectionResponsibilityModel> _action = new RemoveConnectionsAction<OfficeSectionResponsibilityModel>(this);
        _action.disconnect(this.officeTeam);
        return _action;
    }
}
